#include "main_screen.h"
#include "scr_main_screen.h"

static vtft_t *_vtft;
bool SlideSwitch_0_state = true ;
bool SlideSwitch_1_state = true ;
bool SlideSwitch_2_state = false ;
bool SlideSwitch_3_state = false ;
bool on_change = false ;

void main_screen_show( vtft_t *vtft )
{
    _vtft = vtft;
    initialize_main_screen();
    
    vtft_set_current_screen( _vtft, main_screen.screen_data );
    set_SlideSwitch_0( SlideSwitch_0_state ) ;
    set_SlideSwitch_1( SlideSwitch_1_state ) ;
    set_SlideSwitch_2( SlideSwitch_2_state ) ;
    set_SlideSwitch_3( SlideSwitch_3_state ) ;
}

///////////////////////////////////////////////////////////////////////////
//                                 Events
///////////////////////////////////////////////////////////////////////////
void main_screen_OnClick_SlideSwitch_0()
{
    SlideSwitch_0_state = !SlideSwitch_0_state ;
    set_SlideSwitch_0( SlideSwitch_0_state ) ;
    on_change = true ;
}

void main_screen_OnClick_SlideSwitch_1()
{
    SlideSwitch_1_state = !SlideSwitch_1_state ;
    set_SlideSwitch_1( SlideSwitch_1_state ) ;
    on_change = true ;
}

void main_screen_OnClick_SlideSwitch_2()
{
    SlideSwitch_2_state = !SlideSwitch_2_state ;
    set_SlideSwitch_2( SlideSwitch_2_state ) ;
    on_change = true ;
}

void main_screen_OnClick_SlideSwitch_3()
{
    SlideSwitch_3_state = !SlideSwitch_3_state ;
    set_SlideSwitch_3( SlideSwitch_3_state ) ;
    on_change = true ;
}


void set_SlideSwitch_0( bool state )
{
    if ( state )
    {
        main_screen.SlideSwitch_0->press_gradient.start_color = GL_DARK_ORANGE ;
        main_screen.SlideSwitch_0_Slider->left = main_screen.SlideSwitch_0->left + 20 ;
    } else {
        main_screen.SlideSwitch_0->press_gradient.start_color = GL_LIGHT_GRAY ;
        main_screen.SlideSwitch_0_Slider->left = main_screen.SlideSwitch_0->left ;
    }
    vtft_draw_component( _vtft, ( vtft_component * ) main_screen.SlideSwitch_0);
    vtft_draw_component( _vtft, ( vtft_component * ) main_screen.SlideSwitch_0_Slider);
}

void set_SlideSwitch_1( bool state )
{
    if ( state )
    {
        main_screen.SlideSwitch_1->press_gradient.start_color = GL_DARK_ORANGE ;
        main_screen.SlideSwitch_1_Slider->left = main_screen.SlideSwitch_1->left + 20 ;
    } else {
        main_screen.SlideSwitch_1->press_gradient.start_color = GL_LIGHT_GRAY ;
        main_screen.SlideSwitch_1_Slider->left = main_screen.SlideSwitch_1->left ;
    }
    vtft_draw_component( _vtft, ( vtft_component * ) main_screen.SlideSwitch_1);
    vtft_draw_component( _vtft, ( vtft_component * ) main_screen.SlideSwitch_1_Slider);
}

void set_SlideSwitch_2( bool state )
{
    if ( state )
    {
        main_screen.SlideSwitch_2->press_gradient.start_color = GL_DARK_ORANGE ;
        main_screen.SlideSwitch_2_Slider->left = main_screen.SlideSwitch_2->left + 20 ;
    } else {
        main_screen.SlideSwitch_2->press_gradient.start_color = GL_LIGHT_GRAY ;
        main_screen.SlideSwitch_2_Slider->left = main_screen.SlideSwitch_2->left ;
    }
    vtft_draw_component( _vtft, ( vtft_component * ) main_screen.SlideSwitch_2);
    vtft_draw_component( _vtft, ( vtft_component * ) main_screen.SlideSwitch_2_Slider);
}

void set_SlideSwitch_3( bool state )
{
    if ( state )
    {
        main_screen.SlideSwitch_3->press_gradient.start_color = GL_BLACK ;
        main_screen.SlideSwitch_3_Slider->left = main_screen.SlideSwitch_3->left + 20 ;
    } else {
        main_screen.SlideSwitch_3->press_gradient.start_color = GL_LIGHT_GRAY ;
        main_screen.SlideSwitch_3_Slider->left = main_screen.SlideSwitch_3->left ;
    }
    vtft_draw_component( _vtft, ( vtft_component * ) main_screen.SlideSwitch_3);
    vtft_draw_component( _vtft, ( vtft_component * ) main_screen.SlideSwitch_3_Slider);
}


void main_screen_OnClick_SlideSwitch_0_Slider()
{
    main_screen_OnClick_SlideSwitch_0() ;
}

void main_screen_OnClick_SlideSwitch_1_Slider()
{
    main_screen_OnClick_SlideSwitch_1() ;
}

void main_screen_OnClick_SlideSwitch_2_Slider()
{
    main_screen_OnClick_SlideSwitch_2() ;
}

void main_screen_OnClick_SlideSwitch_3_Slider()
{
    main_screen_OnClick_SlideSwitch_3() ;
}
